#!/usr/bin/env python
# -*- coding: utf-8 -*-

# in console aufrufen oder aus einer shell
# /usr/bin/check_cam.sh
# schauen ob eine osam running ist und sie dann stoppen
import os
import shutil
import sys
import time
import requests


import subprocess
import logging
import requests
from shutil import copyfile
from os import remove
from os.path import isfile

# Konfiguration
LOGDIR="/tmp"
LOGFILE=os.path.join(LOGDIR, "kitte888_download_oscam.log")
cpuversion = ''
# Logging einrichten
logging.basicConfig(filename=LOGFILE, level=logging.INFO, format='%(asctime)s - %(message)s')
logging.info("**************************** START *******************************")
#########################################################################################################

def download_file(remote_urloscam, local_path):
    logging.info("download ")
    logging.info(remote_urloscam)
    logging.info(local_path)

    response = requests.get(remote_urloscam)

    logging.info("response1")
    if response.status_code == 200:
        logging.info("response2")
        expected_size = int(response.headers.get('content-length', 0))
        with open(local_path, "wb") as file:
            for chunk in response.iter_content(chunk_size=1024):
                file.write(chunk)

        # Überprüfe die Größe der heruntergeladenen Datei
        actual_size = os.path.getsize(local_path)
        if actual_size == expected_size:
            logging.info("Download abgeschlossen und Dateigröße stimmt überein.")

            try:
                # Alte Datei sichern
                source_path = "/etc/tuxbox/config/oscamicamall/binary/oscamicamall"
                destination_path = "/etc/tuxbox/config/oscamicamall/binary/oscamicamall.old"
                shutil.copy(source_path, destination_path)

                # Neue Datei kopieren
                source_path = "/etc/tuxbox/config/oscamicamall/versionen/oscamicamall"
                destination_path = "/etc/tuxbox/config/oscamicamall/binary/oscamicamall"
                shutil.copy(source_path, destination_path)
                logging.info("file kopiert")

                # Rechte setzen
                subprocess.call(["chmod", "+x", destination_path])
                logging.info("rechte gesetzt ")

                sys.exit(0)  # Erfolg
            except Exception as e:
                logging.error(f"Fehler beim Kopieren oder Rechte setzen: {e}")
                sys.exit(1)  # Fehler beim Kopieren
        else:
            logging.error("Dateigröße stimmt nicht überein.")
            sys.exit(1)  # Datei unvollständig
    else:
        logging.error("Kein gültiger HTTP-Response (nicht 200).")
        sys.exit(1)  # Kein Download

#########################################################################################################

def update_version(cpuversion):
    logging.info("Download oscam schauen welche cpu")
    logging.info("CPU-Info von softcam uebergeben: " + cpuversion)
    # ------------------------------------------ hier wo es reincopiert wird ---------------------------
    local_path = "/etc/tuxbox/config/oscamicamall/versionen/oscamicamall"
    cpu_path = "/etc/tuxbox/config/oscamicamall/versionen/cpu"
    remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscamarm"
    # --------------------------------------------------------------------------------------------------
    # Datei, die die CPU-Informationen enthält

    logging.info("CPU- download url suchen fuer: " + cpuversion)
    if cpuversion == "arm" :
        logging.info("cpu ist eine arm ")
        remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscamarm"
    else:

        if  cpuversion == "mipsel" :
            logging.info("cpu ist eine mipsel")
            remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscammipsel"

        else:

            if  cpuversion == "aarch" :
                logging.info("cpu ist eine aarch")
                remote_urloscam = "https://magentacloud.de/s/dBmmC8JEjiyYTy8/download?path=%2F&files=oscamaarch"
            else:
                logging.info("cpu fehler nicht gefunden")
                sys.exit(1)

    if cpuversion != "none" :
        download_file(remote_urloscam, local_path)
        sys.exit(0)
    else:
        logging.info("cpu info nicht vorhanden kein download ")
        sys.exit(1)
		
if __name__ == "__main__":
    if len(sys.argv) != 2:
        logging.info("CPU-Version fehlt!")

        sys.exit(1)

    cpuversion = sys.argv[1]

    update_version(cpuversion)
